Create Linear Dimensions
 
 
 

Linear dimensions can be aligned or rotated. Aligned dimensions have the dimension line parallel to the line along which the extension line origins lie. Rotated dimensions have the dimension line placed at an angle to the extension line origins.

You create linear dimensions by creating instances of the AlignedDimension and RotatedDimension objects. After you create an instance of a linear dimensions, you can modify the text, the angle of the text, or the angle of the dimension line. The following illustrations show how the type of linear dimension and the placement of the extension line origins affect the angle of the dimension line and text.

When you create an instance of an AlignedDimension object, you have the option to specify the extension line origins, the location of the dimension line, dimension text, and the dimension style to apply. If you do not pass any parameters into the AlignedDimension object constructor, the object is assigned a set of default property values.

The RotatedDimension object constructor offers the same options as the AlignedDimension object constructor, with one exception. The RotatedDimension object constructor takes an additional paramter that specifies the angle at which the dimension line is rotated.

For additional information about creating linear dimensions, see “Create Linear Dimensions” in the AutoCAD User's Guide.

Dimension joglines

Joglines on linear dimensions are not added through a set of properties, but extended data(Xdata). The application name responsible for dimension joglines is ACAD_DSTYLE_DIMJAG_POSITION. The following is an example of the Xdata structure that needs to be appended to a linear dimension.

VB.NET

'' Open the Registered Application table for read
Dim acRegAppTbl As RegAppTable
acRegAppTbl = <transaction>.GetObject(<current_database>.RegAppTableId, _
                                      OpenMode.ForRead)
 
'' Check to see if the app "ACAD_DSTYLE_DIMJAG_POSITION" is
'' registered and if not add it to the RegApp table
If acRegAppTbl.Has("ACAD_DSTYLE_DIMJAG_POSITION") = False Then
    Dim acRegAppTblRec As RegAppTableRecord = New RegAppTableRecord()
 
    acRegAppTblRec.Name = "ACAD_DSTYLE_DIMJAG_POSITION"
 
    acRegAppTbl.UpgradeOpen()
 
    acRegAppTbl.Add(acRegAppTblRec)
    <transaction>.AddNewlyCreatedDBObject(acRegAppTblRec, True)
End If
 
'' Create a result buffer to define the Xdata
Dim acResBuf As ResultBuffer = New ResultBuffer()
acResBuf.Add(New TypedValue(DxfCode.ExtendedDataRegAppName, _
                                    "ACAD_DSTYLE_DIMJAG_POSITION"))
acResBuf.Add(New TypedValue(DxfCode.ExtendedDataInteger16, 387))
acResBuf.Add(New TypedValue(DxfCode.ExtendedDataInteger16, 3))
acResBuf.Add(New TypedValue(DxfCode.ExtendedDataInteger16, 389))
acResBuf.Add(New TypedValue(DxfCode.ExtendedDataXCoordinate, _
                                    New Point3d(-1.26985, 3.91514, 0)))
 
'' Attach the Xdata to the dimension
<dimension_object>.XData = acResBuf

C#

// Open the Registered Application table for read
RegAppTable acRegAppTbl;
acRegAppTbl = <transaction>.GetObject(<current_database>.RegAppTableId,
                                      OpenMode.ForRead) as RegAppTable;
 
// Check to see if the app "ACAD_DSTYLE_DIMJAG_POSITION" is
// registered and if not add it to the RegApp table
if (acRegAppTbl.Has("ACAD_DSTYLE_DIMJAG_POSITION") == false)
{
    RegAppTableRecord acRegAppTblRec = new RegAppTableRecord();
 
    acRegAppTblRec.Name = "ACAD_DSTYLE_DIMJAG_POSITION";
 
    acRegAppTbl.UpgradeOpen();
 
    acRegAppTbl.Add(acRegAppTblRec);
    <transaction>.AddNewlyCreatedDBObject(acRegAppTblRec, true);
}
 
// Create a result buffer to define the Xdata
ResultBuffer acResBuf = new ResultBuffer();
acResBuf.Add(new TypedValue((int)DxfCode.ExtendedDataRegAppName,
                                         "ACAD_DSTYLE_DIMJAG_POSITION"));
acResBuf.Add(new TypedValue((int)DxfCode.ExtendedDataInteger16, 387));
acResBuf.Add(new TypedValue((int)DxfCode.ExtendedDataInteger16, 3));
acResBuf.Add(new TypedValue((int)DxfCode.ExtendedDataInteger16, 389));
acResBuf.Add(new TypedValue((int)DxfCode.ExtendedDataXCoordinate,
                                         new Point3d(-1.26985, 3.91514, 0)));
 
// Attach the Xdata to the dimension
<dimension_object>.XData = acResBuf;
VBA/ActiveX Code Reference

Create a rotated linear dimension

This example creates a rotated dimension in Model space.

VB.NET

Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
 
<CommandMethod("CreateRotatedDimension")> _
Public Sub CreateRotatedDimension()
  '' Get the current database
  Dim acDoc As Document = Application.DocumentManager.MdiActiveDocument
  Dim acCurDb As Database = acDoc.Database
 
  '' Start a transaction
  Using acTrans As Transaction = acCurDb.TransactionManager.StartTransaction()
 
      '' Open the Block table for read
      Dim acBlkTbl As BlockTable
      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, _
                                   OpenMode.ForRead)
 
      '' Open the Block table record Model space for write
      Dim acBlkTblRec As BlockTableRecord
      acBlkTblRec = acTrans.GetObject(acBlkTbl(BlockTableRecord.ModelSpace), _
                                      OpenMode.ForWrite)
 
      '' Create the rotated dimension
      Dim acRotDim As RotatedDimension = New RotatedDimension()
      acRotDim.XLine1Point = New Point3d(0, 0, 0)
      acRotDim.XLine2Point = New Point3d(6, 3, 0)
      acRotDim.Rotation = 0.707
      acRotDim.DimLinePoint = New Point3d(0, 5, 0)
      acRotDim.DimensionStyle = acCurDb.Dimstyle
 
      '' Add the new object to Model space and the transaction
      acBlkTblRec.AppendEntity(acRotDim)
      acTrans.AddNewlyCreatedDBObject(acRotDim, True)
 
      '' Commit the changes and dispose of the transaction
      acTrans.Commit()
  End Using
End Sub

C#

using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;
 
[CommandMethod("CreateRotatedDimension")]
public static void CreateRotatedDimension()
{
  // Get the current database
  Document acDoc = Application.DocumentManager.MdiActiveDocument;
  Database acCurDb = acDoc.Database;
 
  // Start a transaction
  using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())
  {
      // Open the Block table for read
      BlockTable acBlkTbl;
      acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId,
                                   OpenMode.ForRead) as BlockTable;
 
      // Open the Block table record Model space for write
      BlockTableRecord acBlkTblRec;
      acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace],
                                      OpenMode.ForWrite) as BlockTableRecord;
 
      // Create the rotated dimension
      RotatedDimension acRotDim = new RotatedDimension();
      acRotDim.XLine1Point = new Point3d(0, 0, 0);
      acRotDim.XLine2Point = new Point3d(6, 3, 0);
      acRotDim.Rotation = 0.707;
      acRotDim.DimLinePoint = new Point3d(0, 5, 0);
      acRotDim.DimensionStyle = acCurDb.Dimstyle;
 
      // Add the new object to Model space and the transaction
      acBlkTblRec.AppendEntity(acRotDim);
      acTrans.AddNewlyCreatedDBObject(acRotDim, true);
 
      // Commit the changes and dispose of the transaction
      acTrans.Commit();
  }
}
VBA/ActiveX Code Reference